// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from robot_calibration_msgs:msg/Observation.idl
// generated code does not contain a copyright notice

#ifndef ROBOT_CALIBRATION_MSGS__MSG__DETAIL__OBSERVATION__STRUCT_HPP_
#define ROBOT_CALIBRATION_MSGS__MSG__DETAIL__OBSERVATION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'features'
#include "geometry_msgs/msg/detail/point_stamped__struct.hpp"
// Member 'ext_camera_info'
#include "robot_calibration_msgs/msg/detail/extended_camera_info__struct.hpp"
// Member 'cloud'
#include "sensor_msgs/msg/detail/point_cloud2__struct.hpp"
// Member 'image'
#include "sensor_msgs/msg/detail/image__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__robot_calibration_msgs__msg__Observation __attribute__((deprecated))
#else
# define DEPRECATED__robot_calibration_msgs__msg__Observation __declspec(deprecated)
#endif

namespace robot_calibration_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Observation_
{
  using Type = Observation_<ContainerAllocator>;

  explicit Observation_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : ext_camera_info(_init),
    cloud(_init),
    image(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->sensor_name = "";
    }
  }

  explicit Observation_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : sensor_name(_alloc),
    ext_camera_info(_alloc, _init),
    cloud(_alloc, _init),
    image(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->sensor_name = "";
    }
  }

  // field types and members
  using _sensor_name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _sensor_name_type sensor_name;
  using _features_type =
    std::vector<geometry_msgs::msg::PointStamped_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<geometry_msgs::msg::PointStamped_<ContainerAllocator>>>;
  _features_type features;
  using _ext_camera_info_type =
    robot_calibration_msgs::msg::ExtendedCameraInfo_<ContainerAllocator>;
  _ext_camera_info_type ext_camera_info;
  using _cloud_type =
    sensor_msgs::msg::PointCloud2_<ContainerAllocator>;
  _cloud_type cloud;
  using _image_type =
    sensor_msgs::msg::Image_<ContainerAllocator>;
  _image_type image;

  // setters for named parameter idiom
  Type & set__sensor_name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->sensor_name = _arg;
    return *this;
  }
  Type & set__features(
    const std::vector<geometry_msgs::msg::PointStamped_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<geometry_msgs::msg::PointStamped_<ContainerAllocator>>> & _arg)
  {
    this->features = _arg;
    return *this;
  }
  Type & set__ext_camera_info(
    const robot_calibration_msgs::msg::ExtendedCameraInfo_<ContainerAllocator> & _arg)
  {
    this->ext_camera_info = _arg;
    return *this;
  }
  Type & set__cloud(
    const sensor_msgs::msg::PointCloud2_<ContainerAllocator> & _arg)
  {
    this->cloud = _arg;
    return *this;
  }
  Type & set__image(
    const sensor_msgs::msg::Image_<ContainerAllocator> & _arg)
  {
    this->image = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    robot_calibration_msgs::msg::Observation_<ContainerAllocator> *;
  using ConstRawPtr =
    const robot_calibration_msgs::msg::Observation_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<robot_calibration_msgs::msg::Observation_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<robot_calibration_msgs::msg::Observation_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      robot_calibration_msgs::msg::Observation_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<robot_calibration_msgs::msg::Observation_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      robot_calibration_msgs::msg::Observation_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<robot_calibration_msgs::msg::Observation_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<robot_calibration_msgs::msg::Observation_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<robot_calibration_msgs::msg::Observation_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__robot_calibration_msgs__msg__Observation
    std::shared_ptr<robot_calibration_msgs::msg::Observation_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__robot_calibration_msgs__msg__Observation
    std::shared_ptr<robot_calibration_msgs::msg::Observation_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Observation_ & other) const
  {
    if (this->sensor_name != other.sensor_name) {
      return false;
    }
    if (this->features != other.features) {
      return false;
    }
    if (this->ext_camera_info != other.ext_camera_info) {
      return false;
    }
    if (this->cloud != other.cloud) {
      return false;
    }
    if (this->image != other.image) {
      return false;
    }
    return true;
  }
  bool operator!=(const Observation_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Observation_

// alias to use template instance with default allocator
using Observation =
  robot_calibration_msgs::msg::Observation_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace robot_calibration_msgs

#endif  // ROBOT_CALIBRATION_MSGS__MSG__DETAIL__OBSERVATION__STRUCT_HPP_
